"use strict";


{
	C3.Behaviors.mcube_rexspline.Instance = class MCRexSplineInstance extends C3.SDKBehaviorInstanceBase
	{
		constructor(behInst, properties)
		{
			super(behInst);
			
			this._myProperty = 0;
			
			if (properties)
			{
				this._myProperty = properties[0];
			
			
		        this.enabled = (properties[0] === 1);
		        this.speed = properties[1];
		        this.setAngle = (properties[2] !== 0);        
		        this.isLooping = (properties[3] === 1);       
		        this.tension = properties[4];
	        }

	        if (!this.recycled)
	        {
	            this.points = [];
	            this.curSeg = {ptr:-1, t:1,
	                                  p0:null, p1:null, p2:null, p3:null,
	                                  dist:0,                            
	                                  preX:0,
	                                  preY:0};
	        } 
	    
	        this.traveledDist = 0;    
	        this.movingAngle = 0;        
	        this.is_moving = false;
	        this.is_my_call = false;
			this.lastTick = null;

			this.LASTU;
			this.LASTUU;
			this.LASTUUU;

			this.wi = this._inst.GetWorldInfo();
			this._StartTicking();
		}

		Release()
		{
			super.Release();
		}
		
		SaveToJson()
		{
			return {
				// data to store for savegames
			};
		}

		LoadFromJson(o)
		{
			// load state for savegames
		}
		
		Tick()
		{
	        if (!this.enabled || !this.is_moving) {
	            return;
	        } else {
	        	const dt = this._runtime.GetDt(this._inst);
	        	this.move(dt);
	        }
		}

		move(dt) {

	        if (dt == null)
	            //dt = this.runtime.getDt(wi);
	        	dt = this._runtime.GetDt(this._inst);
	        if ((dt === 0) || (this.speed == 0))
	            return;
	        
	        var tickMovingDist = this.speed*dt;
	        var tMD2 = tickMovingDist*tickMovingDist;
	        var sTickMovingDist=tickMovingDist/20;
	        var segDist=null, t; 
	        var x0=this.wi._x, y0=this.wi._y;
	        var seg, nx, ny, dist, dist2, i=0;
	        var preX, preY, preDist2, preSegT;
	        while (1)
	        {
	            seg = this.getSeg();
	            if (seg == null)            
	                break;            
	            if (seg.dist === 0)
	                continue;
	            if (segDist !== seg.dist)
	            {
	                segDist = seg.dist
	                t = (sTickMovingDist/segDist);
	                if (t > 0.5)
	                    t = 0.5;  // 2 points at least
	            }
	            
	            seg.t += t;
	            i++;
	            if (seg.t >= 1)
	            {
	                seg.t = 1;
	                nx = seg.p2[0];
	                ny = seg.p2[1];
	            }
	            else
	            {
	                nx=this.interpolate(seg, 0, this.tension);
	                ny=this.interpolate(seg, 1, this.tension);
	            }
	                
	            dist2 = this.distance2(x0, y0, nx, ny);
	            if (dist2 >= tMD2)
	            {
	                if (Math.abs(preDist2 - tMD2) < Math.abs(dist2 - tMD2))
	                {
	                    nx = preX;
	                    ny = preY;
	                    dist2 = preDist2;
	                    seg.t = preSegT;
	                }

	                dist = Math.sqrt(dist2);
	                this.traveledDist += dist;
	                this.wi.SetX(nx);
	                this.wi.SetY(ny);

	                // debug
	                //var diff = Math.abs(dist-tickMovingDist)/tickMovingDist;
	                //diff = Math.floor(diff*100)/100;
	                //if (diff < 1)
	                //    console.log(tickMovingDist + "," + dist+ " :" + diff + "; " + i);     
	                //else
	                //    console.warn(tickMovingDist + "," + dist+ " :" + diff + "; " + i);  

	                break;
	            }
	            else
	            {
	                preX = nx;
	                preY = ny;
	                preDist2 = dist2;
	                preSegT = (seg.t === 1)? 0:seg.t;
	            }
	        } // while(1)
	                   
	        if ((x0 === this.wi._x) && (y0 === this.wi._y)) {
	            //this.movingAngle = this.wi.angle;
	        }
	        else {      
	            this.movingAngle = C3.angleTo(x0, y0, this.wi._x, this.wi._y);
	        } 

	        if (this.setAngle) {
	        	if(this.is_moving) {
	            	this.wi.SetAngle(this.movingAngle);
	            }
	        }
	        
	        if (this.speed !== 0)
	        {
	            this.wi.SetBboxChanged();
	        
	            if (seg == null)
	            {
	                this.onReachLastPoint();
	            }
	            else
	            {
	                seg.preX = nx;
	                seg.preY = ny;
	            }
	        }
		}

		start() {
	        this.curSeg.ptr = -1;
	        this.curSeg.t = 1;
	        this.traveledDist = 0;
	        this.is_moving = true;
	        
	        var seg = this.getSeg();
	        if (seg === null)
	            this.onReachLastPoint();
        }

		onReachLastPoint()
		{
	        if (!this.is_moving)
	            return;
	        
	        this.is_moving = false;  // stop
	        this.is_my_call = true;
	        this.Trigger(C3.Behaviors.mcube_rexspline.Cnds.OnHitTarget, this.wi);
	        this.is_my_call = false;
		}

		hitPoint()
		{
	        this.is_my_call = true;
	        this.Trigger(C3.Behaviors.mcube_rexspline.Cnds.OnHitAnyPoint, this.wi); 
	        this.is_my_call = false;
		}

	    wrapIndex(idx)
	    {
	        if (this.isLooping)
	        {
	            var cnt = this.points.length;   
	            idx = idx % cnt;
	            if (idx < 0)
	                idx = cnt + idx;
	        }
	        
	        return idx;
	    }

		getSeg()
		{
	        if (this.curSeg.t === 1)       
	        {       
	            this.curSeg.ptr = this.wrapIndex(this.curSeg.ptr + 1);
	            var ptr1 =  this.curSeg.ptr;
	            var ptr2 = this.wrapIndex(ptr1 + 1); 
	            
	            if (ptr2 >= this.points.length)
	                return null;
	            
	            var ptr0 = this.wrapIndex(ptr1 - 1);
	            var ptr3 = this.wrapIndex(ptr2 + 1);
	            
	            this.curSeg.p0 = this.points[ptr0];
	            this.curSeg.p1 = this.points[ptr1];
	            this.curSeg.p2 = this.points[ptr2];
	            this.curSeg.p3 = this.points[ptr3];
	            this.curSeg.dist = C3.distanceTo(this.curSeg.p1[0], this.curSeg.p1[1], this.curSeg.p2[0], this.curSeg.p2[1]);   
	            this.curSeg.t = 0;
	            this.curSeg.preX = this.curSeg.p1[0];
	            this.curSeg.preY = this.curSeg.p1[1];  

	            this.hitPoint();            
	        }
	        
	        return this.curSeg;              
		}

	    
		interpolate(seg, i, tension)
		{
	        var p1 = seg.p1[i];
	        var p2 = seg.p2[i];
	        var t = seg.t;
	        var p0 = (seg.p0)? seg.p0[i] : p1+(p1-p2);
	        var p3 = (seg.p3)? seg.p3[i] : p2+(p2-p1);

	        var u, uu, uuu;
	        if (t === this.LASTU)
	        {
	            u = this.LASTU;
	            uu = this.LASTUU;
	            uuu = this.LASTUUU;
	        }
	        else
	        {
	            this.LASTU = u = t;
	            this.LASTUU = uu = u*u;
	            this.LASTUUU = uuu = uu*u;
	        }

	        return (-tension*u +2*tension*uu -tension*uuu)*p0 + 
	                   (+1 +(tension-3)*uu +(2-tension)*uuu)*p1 +
	                   (+tension*u +(3-2*tension)*uu +(tension-2)*uuu)*p2 +
	                   (-tension*uu +tension*uuu)*p3;
		}

	    din(d, default_value)
	    {       
	        var o;
		    if (d === true)
		        o = 1;
		    else if (d === false)
		        o = 0;
	        else if (d == null)
	        {
	            if (default_value != null)
	                o = default_value;
	            else
	                o = 0;
	        }
	        else if (typeof(d) == "object")
	            o = JSON.stringify(d);
	        else
	            o = d;
		    return o;
	    }

		distance2(x0, y0, x1, y1)
		{
			var dx = (x1-x0);
			var dy = (y1-y0);
			return dx*dx + dy*dy;
		}

		isTickChanged () {
			var curTick = this._runtime.GetTickCount();
			var tickChanged = (this.lastTick != curTick);
			this.lastTick = curTick;
			return tickChanged;
		}

		getMovingAngle (ret) {
			if (this.isTickChanged()) {
				return to_clamped_degrees(this.movingAngle);
			}

		}
	};
}

var clamp_angle_degrees = function (a)
{
	// Clamp in degrees
	a %= 360;       // now in (-360, 360) range

	if (a < 0)
		a += 360;   // now in [0, 360) range

	return a;
};

var to_degrees = function(x)
{
	return x * (180.0 / Math.PI);
};

var to_clamped_degrees = function (x)
{
	// Convert x from radians to [0, 360) range
	return clamp_angle_degrees(to_degrees(x));
};